using System;

namespace MoonWorks.Audio
{
	/// <summary>
	/// SourceVoices can send audio to a SubmixVoice for convenient effects processing.
	/// </summary>
	public class SubmixVoice : Voice
	{
		public SubmixVoice(
			AudioDevice device,
			uint sourceChannelCount,
			uint sampleRate
		) : base(device, sourceChannelCount, device.DeviceDetails.OutputFormat.Format.nChannels)
		{
			FAudio.FAudio_CreateSubmixVoice(
				device.Handle,
				out handle,
				sourceChannelCount,
				sampleRate,
				FAudio.FAUDIO_VOICE_USEFILTER,
				0,
				IntPtr.Zero, // default sends to mastering voice
				IntPtr.Zero
			);
		}
	}
}
